---
title: Number.MAX_SAFE_INTEGER
slug: Web/JavaScript/Reference/Global_Objects/Number/MAX_SAFE_INTEGER
tags:
  - ECMAScript 2015
  - JavaScript
  - Number
  - Property
---
<div>{{JSRef}}</div>

<p>The <strong><code>Number.MAX_SAFE_INTEGER</code></strong> constant represents the maximum safe integer in JavaScript (<code>2<sup>53</sup> - 1</code>).</p>

<p>For larger integers, consider using {{jsxref("BigInt")}}.</p>

<div>{{EmbedInteractiveExample("pages/js/number-maxsafeinteger.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<div>{{js_property_attributes(0, 0, 0)}}</div>

<h2 id="Description">Description</h2>

<p>The <code>MAX_SAFE_INTEGER</code> constant has a value of <code>9007199254740991</code> (9,007,199,254,740,991 or ~9 quadrillion). The reasoning behind that number is that JavaScript uses <a href="http://en.wikipedia.org/wiki/Double_precision_floating-point_format">double-precision floating-point format numbers</a> as specified in <a href="http://en.wikipedia.org/wiki/IEEE_floating_point">IEEE 754</a> and can only safely represent integers between <code>-(2<sup>53</sup> - 1)</code> and <code>2<sup>53</sup> - 1</code>.</p>

<p>Safe in this context refers to the ability to represent integers exactly and to correctly compare them. For example, <code>Number.MAX_SAFE_INTEGER + 1 === Number.MAX_SAFE_INTEGER + 2</code> will evaluate to true, which is mathematically incorrect. See {{jsxref("Number.isSafeInteger()")}} for more information.</p>

<p>This field does not exist in old browsers. Using it without checking its existence, such as <code>Math.max(Number.MAX_SAFE_INTEGER, 2)</code>, will yield undesired results such as NaN.</p>

<p>Because <code>MAX_SAFE_INTEGER</code> is a static property of {{jsxref("Number")}}, you always use it as <code>Number.MAX_SAFE_INTEGER</code>, rather than as a property of a {{jsxref("Number")}} object you created.</p>

<h2 id="Polyfill">Polyfill</h2>

<pre class="brush: js notranslate">if (!Number.MAX_SAFE_INTEGER) {
    Number.MAX_SAFE_INTEGER = 9007199254740991; // Math.pow(2, 53) - 1;
}
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Return_value_of_MAX_SAFE_INTEGER">Return value of MAX_SAFE_INTEGER</h3>

<pre class="brush: js notranslate">Number.MAX_SAFE_INTEGER; // 9007199254740991
</pre>

<h3 id="Numbers_higher_than_safe_integer">Numbers higher than safe integer</h3>

<p>This returns 2 because in floating points, the value is actually the decimal trailing "1" except for in subnormal precision cases such as zero.</p>

<pre class="brush: js notranslate">Number.MAX_SAFE_INTEGER * Number.EPSILON; // 2
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-number.max_safe_integer', 'Number.MAX_SAFE_INTEGER')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Number.MAX_SAFE_INTEGER")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Number.MIN_SAFE_INTEGER")}}</li>
 <li>{{jsxref("Number.isSafeInteger()")}}</li>
 <li>{{jsxref("BigInt")}}</li>
</ul>
